#include <project.h>

static int32_t saw[128] = {0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,
       17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33,
       34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50,
       51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 63, 62, 61,
       60, 59, 58, 57, 56, 55, 54, 53, 52, 51, 50, 49, 48, 47, 46, 45, 44,
       43, 42, 41, 40, 39, 38, 37, 36, 35, 34, 33, 32, 31, 30, 29, 28, 27,
       26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10,
        9,  8,  7,  6,  5,  4,  3,  2,  1};


volatile int comp_updated = 0 ;
volatile uint32_t msb_value = 0 ;

CY_ISR(ISR_MSB_UPDATE)
{
    PWM_MSB_INTERRUPT_REQ_REG = PWM_MSB_INTR_MASK_TC ;
    if (comp_updated) {
        PWM_MSB_COMP_CAP_REG = msb_value ;
        comp_updated = 0 ;
    }
}

CY_ISR(ISR_SAW_GENERATOR) {
    static uint8_t tbl_idx = 0;

    PWM_UPDATE_INTERRUPT_REQ_REG = PWM_UPDATE_INTR_MASK_TC; // ClearInterrupt
    
    UPDATE_DR |= UPDATE_MASK ;    
    msb_value = saw[((tbl_idx++) & 127)];
    comp_updated = 1 ;
    UPDATE_DR &= ~UPDATE_MASK ;
/*    
    uint32_t msb = saw[((tbl_idx++) & 127)];
    UPDATE_DR |= UPDATE_MASK;
    PWM_MSB_COMP_CAP_REG = msb;
    UPDATE_DR &= ~UPDATE_MASK;
*/
}


/*----------------------------------------------------------*/
/* PSoC Start                                               */
/*----------------------------------------------------------*/

int main(void) {   
    PWM_MSB_Start();
    isr_MSB_TC_StartEx(ISR_MSB_UPDATE) ;
    PWM_UPDATE_Start();
    isr_PWM_UPDATE_StartEx(ISR_SAW_GENERATOR);
    PWM_UPDATE_WritePeriod(200);
    
    CyGlobalIntEnable;
    
    while (1) {  
        CyDelay(2000);  // Restart PWM update to achive different write time
        isr_PWM_UPDATE_Disable();
        CyDelay(500);
        isr_PWM_UPDATE_StartEx(ISR_SAW_GENERATOR);
    }
}

